
local characters = {['f1']='',['f2']='',['f3']='',['f4']='',['f5']='',['f6']='',['f7']='',['f8']='',
					['f9']='',['f10']='',['f11']='',['f12']='',['f11']='',['f12']='',['f11']='',['f12']='',
					['f13']='',['f14']='',['f15']='',['insert']='',['backspace']='',['clear']='',['return']='\n',
					['delete']='',['up']='',['down']='',['right']='',['left']='',['home']='',['end']='',
					['pageup']='',['pagedown']='',['kp0']='0',['kp1']='1',['kp2']='2',['kp3']='3',
					['kp4']='4',['kp5']='5',['kp6']='6',['kp7']='7',['kp8']='8',['kp9']='9',['kp.']='.',
					['kp/']='/',['kp*']='*',['kp-']='-',['kp+']='+',['kpenter']='\n',['kp=']='=',
					['numlock']='',['capslock']='',['scrollock']='',['rshift']='',['lshift']='',
					['rctrl']='',['lctrl']='',['ralt']='',['rmeta']='',['lmeta']='',['rsuper']='',
					['lsuper']='',['mode']='',['compose']='',['pause']='',['escape']='',['help']='',
					['print']='',['sysreq']='',['break']='',['menu']='',['power']='',['euro']='',
					['undo']='', ['tab']='', ['lalt']=''}

local shiftKeysUS = { ['1']='!', ['2']='@', ['3']='#', ['4']='$', ['5']='%',['6']='^', ['7']='&', ['8']='*', ['9']='(',
					['0']=')', ['`']='~', q='Q', w='W', e='E', r='R', t='T', y='Y', u='U', i='I',
					o="O", p='P', a='A', s='S', d='D', f='F', g='G', h='H', j='J', k='K', l='L',
					z='Z', x='X', c='C', v='V', b='B', n='N', m='M', [',']='<', ['.']='>', ['/']='?', 
					[';']=':', ["'"]='"', ['[']='{', [']']='}', ['\\']='|', ['-']='_', ['=']='+'}

-- Copy the shift keys from the US layout to the UK layout
local shiftKeysUK = {}
for k,v in pairs(shiftKeysUS) do
	shiftKeysUK[k] = v
end

-- Change the 
shiftKeysUK['`']=''
shiftKeysUK['2']='"'
shiftKeysUK['3']=''
shiftKeysUK["'"]='@'
shiftKeysUK['#']='~'

-- We're going to stick out functions in this
local Type = {}
-- The current shift mode
local currentShift = shiftKeysUS

-- Set the keyboard layout to 'US' (ANSI) or 'UK' (ISO 9995-3)
function Type.setLayout(layout)
	if layout == 'UK' then currentShift = shiftKeysUK end
	if layout == 'US' then currentShift = shiftKeysUS end
end

-- Feed this a love key constant and it returns a typed character
function Type.key(k)
	local shift = love.keyboard.isDown('lshift') or love.keyboard.isDown('rshift') 
	if love.keyboard.isDown('capslock') then shift = not shift end
	return (shift and currentShift[k]) or characters[k] or k
end

setmetatable(Type, {__call = function(t,k) return Type.key(k) end})
return Type
